## libdsme-0.66.8-2.src.tar.gz

=== Makefile ===
# Package version
VERSION   := 0.66.8

# Shared object version
SOMAJOR   := .0
SOMINOR   := .3
SORELEASE := .0

SOLINK    := .so
SONAME    := .so$(SOMAJOR)
SOVERS    := .so$(SOMAJOR)$(SOMINOR)$(SORELEASE)

# Files to build / install
TARGETS_LIB    += libdsme.a

TARGETS_DSO    += libdsme$(SOVERS)
TARGETS_DSO    += libdsme_dbus_if$(SOVERS)
TARGETS_DSO    += libthermalmanager_dbus_if$(SOVERS)

INSTALL_HDR    += include/dsme/protocol.h
INSTALL_HDR    += include/dsme/messages.h
INSTALL_HDR    += include/dsme/alarm_limit.h
INSTALL_HDR    += include/dsme/processwd.h
INSTALL_HDR    += include/dsme/state.h
INSTALL_HDR    += include/dsme/state_states.h
INSTALL_HDR    += modules/dsme_dbus_if.h
INSTALL_HDR    += modules/thermalmanager_dbus_if.h

INSTALL_PC     += dsme.pc
INSTALL_PC     += dsme_dbus_if.pc
INSTALL_PC     += thermalmanager_dbus_if.pc

TARGETS_UT_BIN += tests/ut_libdsme
INSTALL_UT_XML += tests/tests.xml

TARGETS_ALL    += $(TARGETS_LIB) $(TARGETS_DSO) $(TARGETS_UT_BIN)

# Dummy default install dir - override from packaging scripts
DESTDIR ?= /tmp/libdsme-test-install

# Define LIBDIR so we can override it if needed
LIBDIR  ?= /usr/lib

# ----------------------------------------------------------------------------
# Top level targets
# ----------------------------------------------------------------------------

.PHONY: build install clean distclean mostlyclean

build:: $(TARGETS_ALL)

install:: build

clean:: mostlyclean
	$(RM) $(TARGETS_ALL)

distclean:: clean

mostlyclean::
	$(RM) *.o *~ */*.o */*~

install :: install_main install_devel install_tests

install_main::
	# dynamic libraries
	install -d -m 755 $(DESTDIR)$(LIBDIR)
	install -m 755 $(TARGETS_DSO) $(DESTDIR)$(LIBDIR)

install_devel::
	# headers
	install -d -m 755 $(DESTDIR)/usr/include/dsme
	install -m 644 $(INSTALL_HDR) $(DESTDIR)/usr/include/dsme
	# pkg config
	install -d -m 755 $(DESTDIR)$(LIBDIR)/pkgconfig
	install -m 644 $(INSTALL_PC) $(DESTDIR)$(LIBDIR)/pkgconfig
	# static libraries
	install -d -m 755 $(DESTDIR)$(LIBDIR)
	install -m 644 $(TARGETS_LIB) $(DESTDIR)$(LIBDIR)
	# symlinks for dynamic linking
	for f in $(TARGETS_DSO); do \
	  ln -sf $$(basename $$f $(SOVERS))$(SONAME) \
	    $(DESTDIR)$(LIBDIR)/$$(basename $$f $(SOVERS))$(SOLINK); \
	done

install_tests::
	# xml
	install -d -m 755 $(DESTDIR)/opt/tests/libdsme
	install -m644 $(INSTALL_UT_XML) $(DESTDIR)/opt/tests/libdsme
	# binary
	install -m755 $(TARGETS_UT_BIN) $(DESTDIR)/opt/tests/libdsme

# ----------------------------------------------------------------------------
# Build rules
# ----------------------------------------------------------------------------

%.pic.o     : %.c ; $(CC) -o $@ -c $< -fPIC $(CPPFLAGS) $(CFLAGS)
%.o         : %.c ; $(CC) -o $@ -c $< $(CPPFLAGS) $(CFLAGS)
%$(SOVERS)  :     ; $(CC) -o $@ -shared -Wl,-soname,$*$(SONAME) $^ $(LDFLAGS) $(LDLIBS)
%           : %.o ; $(CC) -o $@ $^ $(LDFLAGS) $(LDLIBS)
%.a         :     ; $(AR) ru $@ $^

# ----------------------------------------------------------------------------
# Common options
# ----------------------------------------------------------------------------

CFLAGS   += -std=c99
CFLAGS   += -O2
CFLAGS   += -Wall
CFLAGS   += -Wwrite-strings
CFLAGS   += -Wmissing-prototypes
CFLAGS   += -Werror

CFLAGS   += -g
LDFLAGS  += -g

LDFLAGS  += -Wl,--as-needed

# ----------------------------------------------------------------------------
# libdsme$(SOVERS) and libdsme.a
# ----------------------------------------------------------------------------

libdsme_OBJ += protocol.pic.o message.pic.o alarm_limit.pic.o
libdsme_PC  += glib-2.0

libdsme$(SOVERS) : CFLAGS += $$(pkg-config --cflags $(libdsme_PC))
libdsme$(SOVERS) : LDLIBS += $$(pkg-config --libs $(libdsme_PC))
libdsme$(SOVERS) : $(libdsme_OBJ)

libdsme.a : CFLAGS += $$(pkg-config --cflags $(libdsme_PC))
libdsme.a : $(patsubst %.pic.o, %.o, $(libdsme_OBJ))

# ----------------------------------------------------------------------------
# libdsme_dbus_if$(SOVERS)
# ----------------------------------------------------------------------------

libdsme_dbus_if_OBJ += modules/dsme_dbus_if.pic.o

libdsme_dbus_if$(SOVERS) : $(libdsme_dbus_if_OBJ)

# ----------------------------------------------------------------------------
# libthermalmanager_dbus_if$(SOVERS)
# ----------------------------------------------------------------------------

libthermalmanager_dbus_if_OBJ += modules/thermalmanager_dbus_if.pic.o

libthermalmanager_dbus_if$(SOVERS) : $(libthermalmanager_dbus_if_OBJ)

# ----------------------------------------------------------------------------
# ut_libdsme
# ----------------------------------------------------------------------------

ut_libdsme_OBJ += tests/ut_libdsme.o
ut_libdsme_PC  += glib-2.0 check

tests/ut_libdsme : CFLAGS += $$(pkg-config --cflags $(ut_libdsme_PC))
tests/ut_libdsme : LDLIBS += $$(pkg-config --libs $(ut_libdsme_PC))
tests/ut_libdsme : $(ut_libdsme_OBJ) libdsme$(SOVERS)

=== debian/changelog ===
libdsme (0.66.8) unstable; urgency=low

  * [protocol] Fix build with -Werror=use-after-free
  * [protocol] Remove unnecessary casts
  * [protocol] Remove pointer aliasing. JB#49555

 -- Simo Piiroinen <simo.piiroinen@jolla.com>  Tue, 04 Oct 2022 12:36:57 +0300

libdsme (0.66.7) unstable; urgency=low

  * [ut_libdsme] Fix random test failures. Fixes JB#57276

 -- Simo Piiroinen <simo.piiroinen@jolla.com>  Thu, 03 Mar 2022 10:46:51 +0200

libdsme (0.66.6) unstable; urgency=low

  * Replace u_int*_t usages for the newer uint*_t

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Thu, 24 Sep 2020 18:42:41 +0300

libdsme (0.66.5) unstable; urgency=low

  * [protocol,alarm] use C extern in the headers

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Thu, 10 Sep 2020 12:30:00 +0300

libdsme (0.66.4) unstable; urgency=low

  * [packaging] Install library as executable. JB#51013

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Tue, 01 Sep 2020 10:17:04 +0300

libdsme (0.66.3) unstable; urgency=low

  * [aarch64] Specify libdir. Contributes to JB#49681

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Mon, 25 May 2020 16:29:33 +0300

libdsme (0.66.2) unstable; urgency=low

  * [packaging] Fix license, update URL. Contributes to JB#45486

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Thu, 01 Aug 2019 09:01:40 +0300

libdsme (0.66.1) unstable; urgency=low

  * [packaging] Use %license for license files. Contributes to JB#24119
  * [protocol] Fix compilation error due to undeclared writev(). Fixes JB#45208

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Thu, 21 Mar 2019 14:16:53 +0200

libdsme (0.66.0) unstable; urgency=low

  * [messages] Add DSM_MSGTYPE_SET_BATTERY_LEVEL. JB#41302

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Tue, 10 Apr 2018 21:41:53 +0300

libdsme (0.65.0) unstable; urgency=low

  * [protocol] Fix message io vector size calculation
  * [protocol] Set errno when abandoning dsmesock_send_with_extra()
  * [messages] Make dsme message type identifiers unique. JB#38500

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Wed, 04 Apr 2018 08:42:03 +0300

libdsme (0.64.2) unstable; urgency=low

  * [license] Unify open source licenses. Contributes to JB#33648

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Wed, 16 Dec 2015 08:14:33 +0200

libdsme (0.64.1) unstable; urgency=low

  * [packaging] Add missing execute bit to unit test binary. Fixes JB#29776
  * [packaging] Make rpms own the directories where files are installed.
     Contributes to JB#29776

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Wed, 10 Jun 2015 10:03:43 +0300

libdsme (0.64.0) unstable; urgency=low

  * [packaging] Use wildcards for filename matching (Contributes to JB#12048)
  * [spec] Remove spectacle cruft (Contributes to JB#12048)
  * [build] Rewrite Makefile
  * [cleanup] Remove .gitignore
  * [packaging] Fix soname used by the libraries. Contributes to JB#12048
  * [packaging] Bring version number in Makefile up to date
  * [packaging] Make sure the various version numbers stay in sync
  * [build] Bump dynamic library versions to 0.3.0. Contributes to JB#12048
  * [cleanup] Remove unsused .todo file

 -- Simo Piiroinen <simo.piiroinen@jollamobile.com>  Thu, 04 Jun 2015 11:30:45 +0300

libdsme (0.61.6) unstable; urgency=low

  * add dsme_snooze_timeout_in_seconds() (Fixes: NB#218425)

 -- Semi Malinen <semi.malinen@nokia.com>  Tue, 22 Feb 2011 08:55:04 +0000

libdsme (0.61.5) unstable; urgency=low

  * add debian/api

 -- Semi Malinen <semi.malinen@nokia.com>  Sat, 03 Jul 2010 19:45:38 +0000

libdsme (0.61.4) unstable; urgency=low

  * add dsme_state_change_ind and dsme_get_state

 -- Semi Malinen <semi.malinen@nokia.com>  Thu, 20 May 2010 02:00:27 +0000

libdsme (0.61.3) unstable; urgency=low

  * minor change: drop prefix from DSME internal state names

 -- Semi Malinen <semi.malinen@nokia.com>  Tue, 18 May 2010 20:40:17 +0000

libdsme (0.61.2) unstable; urgency=low

  * add D-Bus i/f for Thermal Manager

 -- Semi Malinen <semi.malinen@nokia.com>  Wed, 31 Mar 2010 18:33:58 +0000

libdsme (0.61.1) unstable; urgency=low

  * add battery_empty_ind

 -- Semi Malinen <semi.malinen@nokia.com>  Fri, 20 Nov 2009 12:47:33 +0000

libdsme (0.61.0) unstable; urgency=low

  * Release for Harmattan

 -- Semi Malinen <semi.malinen@nokia.com>  Mon, 02 Nov 2009 15:48:09 +0000

libdsme (0.60.29) unstable; urgency=low

  * Fixes: NB#132619: Split libdsme into a separate source package

 -- Semi Malinen <semi.malinen@nokia.com>  Thu, 03 Sep 2009 11:16:47 +0300

dsme (0.60.28) unstable; urgency=low

  * Partial fix to NB#127466: remove a 2 s delay from shutdown
  * Once committed, do not stop thermal shutdown even if temps come down

 -- Semi Malinen <semi.malinen@nokia.com>  Wed, 02 Sep 2009 07:42:42 +0000

dsme (0.60.27) unstable; urgency=low

  * Fixes: NB#127507: partial fixes as follows
  * add high priority thread to kick hwwd's and wake up main thread
  * call g_thread_init()
  * protect all threads from OOM killer

 -- Semi Malinen <semi.malinen@nokia.com>  Sun, 23 Aug 2009 14:30:46 +0000

dsme (0.60.26) unstable; urgency=low

  * Fixes: NB#127507: partial fixes as follows
  * use helper app to avoid being non-async-signal-safe before exec
  * use -pthread gcc flag all over
  * only try to open thermal tuning file while in TA test
  * offload alarm state saving to the logger thread

 -- Semi Malinen <semi.malinen@nokia.com>  Tue, 18 Aug 2009 10:07:14 +0000

dsme (0.60.25) unstable; urgency=low

  * Part of the fix for NB#127507: do not block in parent when spawning
  * Fixes: NB#132451: detect mass storage mode properly

 -- Semi Malinen <semi.malinen@nokia.com>  Fri, 14 Aug 2009 10:37:56 +0000

dsme (0.60.24) unstable; urgency=low

  * Part of the fix for NB#123145: only prevent shutdown/reboot in USER mode

 -- Semi Malinen <semi.malinen@nokia.com>  Sun, 09 Aug 2009 09:58:33 +0000

dsme (0.60.23) unstable; urgency=low



=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>

pkgname=libdsme
pkgver=0.66.8
pkgrel=2
pkgdesc="DSME dsmesock dynamic library"
arch=('x86_64')
url="https://github.com/sailfishos/libdsme"
license=('LGPL')
depends=('glib2')
makedepends=('check')
source=("https://github.com/sailfishos/libdsme/archive/$pkgver/$pkgname-$pkgver.tar.gz")
sha512sums=('8f5245ba0d3a5e17051007017605ba8e69521b70f86376f6106a1bc12d7fef38941491b3e8dbbad732aeb557753f9c937c3494dfe6dd445bb2b3018cc71617af')

build() {
  cd $pkgname-$pkgver
  ./verify_version
  make
}

package() {
  cd $pkgname-$pkgver
  make DESTDIR="${pkgdir}" install_main install_devel

  # Fix symlinks
  for name in libdsme libdsme_dbus_if libthermalmanager_dbus_if; do
    ln -sf $name.so.0.3.0 "$pkgdir"/usr/lib/$name.so.0
    ln -sf $name.so.0.3.0 "$pkgdir"/usr/lib/$name.so
  done
}

=== debian/control ===
Source: libdsme
Section: misc
Priority: optional
Maintainer: Antti Virtanen <antti.i.virtanen@nokia.com>
Uploaders: Ismo Laitinen <ismo.laitinen@nokia.com>, David Weinehall <david.weinehall@nokia.com>, Philippe De Swert <philippe.de-swert@nokia.com>
Build-Depends: debhelper (>= 4.1.0),
 pkg-config,
 libglib2.0-dev
Standards-Version: 3.7.2

Package: libdsme0.2.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: libdsme0
Description: DSME dsmesock dynamic library
 This package contains dynamic libraries for programs that communicate with the
 Device State Management Entity.

Package: libdsme0.2.0-dbg
Section: libdevel
Priority: extra
Architecture: any
Depends: libdsme0.2.0 (= ${binary:Version})
Description: DSME dsmesock dynamic library (with debug symbols)
 This package contains dynamic libraries for programs that communicate with the
 Device State Management Entity.

Package: libdsme0.2.0-dev
Section: libdevel
Architecture: any
Depends: libdsme0.2.0 (= ${binary:Version})
Description: Development files for dsme
 This package contains headers and static libraries needed to develop programs
 that want to communicate with the Device State Management Entity.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# To build testcases as well, add "testcases" to DEB_BUILD_OPTIONS
ifneq (,$(findstring testcases,$(DEB_BUILD_OPTIONS)))
	DH_OPTIONS=
else
	DH_OPTIONS=-Ndsme-testcases
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp

#Architecture
build: build-stamp

build-stamp: configure-stamp

# To build testcases as well, add "testcases" to DEB_BUILD_OPTIONS
ifneq (,$(findstring testcases,$(DEB_BUILD_OPTIONS)))
	$(MAKE) tests
else
	$(MAKE)
endif

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) distclean

	dh_clean

install:
	dh_testdir
	dh_testroot
	dh_clean -k -s
	dh_installdirs

	# Add here commands to install the package into
	# debian/tmp.
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	#mkdir $(CURDIR)/debian/tmp/etc/dsme

	# install tests (if needed)
ifneq (,$(findstring testcases,$(DEB_BUILD_OPTIONS)))
	$(MAKE) tests_install DESTDIR=$(CURDIR)/debian/tmp
endif

	dh_install -s

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs -XREADME
	dh_installexamples
	dh_installman
	dh_link
	dh_strip --dbg-package=libdsme0.2.0
	dh_compress
	dh_fixperms
	dh_makeshlibs --exclude=/usr/lib/dsme/
	dh_installdeb
	dh_shlibdeps -l$(CURDIR)/debian/libdsme0.2.0/usr/lib
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build install
#	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
#binary-arch: build install
#	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure
